<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;v9jmyrpcwymx5d6inidy85x2ljzgm935-vendored-sources&#x2F;syn-1.0.86&#x2F;src&#x2F;mac.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>mac.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../syn/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::token</span>::{<span class="ident">Brace</span>, <span class="ident">Bracket</span>, <span class="ident">Paren</span>};
<span class="kw">use</span> <span class="ident">proc_macro2::TokenStream</span>;
<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;parsing&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident">proc_macro2</span>::{<span class="ident">Delimiter</span>, <span class="ident">Group</span>, <span class="ident">Span</span>, <span class="ident">TokenTree</span>};

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;parsing&quot;</span>)]</span>
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::parse</span>::{<span class="ident">Parse</span>, <span class="ident">ParseStream</span>, <span class="ident">Parser</span>, <span class="prelude-ty">Result</span>};

<span class="macro">ast_struct!</span> {
    <span class="doccomment">/// A macro invocation: `println!(&quot;{}&quot;, mac)`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// *This type is available only if Syn is built with the `&quot;derive&quot;` or `&quot;full&quot;`</span>
    <span class="doccomment">/// feature.*</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">doc_cfg</span>, <span class="ident">doc</span>(<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;full&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;derive&quot;</span>))))]</span>
    <span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Macro</span> {
        <span class="kw">pub</span> <span class="ident">path</span>: <span class="ident">Path</span>,
        <span class="kw">pub</span> <span class="ident">bang_token</span>: <span class="macro">Token!</span>[<span class="op">!</span>],
        <span class="kw">pub</span> <span class="ident">delimiter</span>: <span class="ident">MacroDelimiter</span>,
        <span class="kw">pub</span> <span class="ident">tokens</span>: <span class="ident">TokenStream</span>,
    }
}

<span class="macro">ast_enum!</span> {
    <span class="doccomment">/// A grouping token that surrounds a macro body: `m!(...)` or `m!{...}` or `m![...]`.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// *This type is available only if Syn is built with the `&quot;derive&quot;` or `&quot;full&quot;`</span>
    <span class="doccomment">/// feature.*</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">doc_cfg</span>, <span class="ident">doc</span>(<span class="ident">cfg</span>(<span class="ident">any</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;full&quot;</span>, <span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;derive&quot;</span>))))]</span>
    <span class="kw">pub</span> <span class="kw">enum</span> <span class="ident">MacroDelimiter</span> {
        <span class="ident">Paren</span>(<span class="ident">Paren</span>),
        <span class="ident">Brace</span>(<span class="ident">Brace</span>),
        <span class="ident">Bracket</span>(<span class="ident">Bracket</span>),
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;parsing&quot;</span>)]</span>
<span class="kw">fn</span> <span class="ident">delimiter_span_close</span>(<span class="ident">macro_delimiter</span>: <span class="kw-2">&amp;</span><span class="ident">MacroDelimiter</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Span</span> {
    <span class="kw">let</span> <span class="ident">delimiter</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">macro_delimiter</span> {
        <span class="ident">MacroDelimiter::Paren</span>(<span class="kw">_</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">Delimiter::Parenthesis</span>,
        <span class="ident">MacroDelimiter::Brace</span>(<span class="kw">_</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">Delimiter::Brace</span>,
        <span class="ident">MacroDelimiter::Bracket</span>(<span class="kw">_</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">Delimiter::Bracket</span>,
    };
    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">group</span> <span class="op">=</span> <span class="ident">Group::new</span>(<span class="ident">delimiter</span>, <span class="ident">TokenStream::new</span>());
    <span class="ident">group</span>.<span class="ident">set_span</span>(<span class="kw">match</span> <span class="ident">macro_delimiter</span> {
        <span class="ident">MacroDelimiter::Paren</span>(<span class="ident">token</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">token</span>.<span class="ident">span</span>,
        <span class="ident">MacroDelimiter::Brace</span>(<span class="ident">token</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">token</span>.<span class="ident">span</span>,
        <span class="ident">MacroDelimiter::Bracket</span>(<span class="ident">token</span>) <span class="op">=</span><span class="op">&gt;</span> <span class="ident">token</span>.<span class="ident">span</span>,
    });
    <span class="ident">group</span>.<span class="ident">span_close</span>()
}

<span class="kw">impl</span> <span class="ident">Macro</span> {
    <span class="doccomment">/// Parse the tokens within the macro invocation&#39;s delimiters into a syntax</span>
    <span class="doccomment">/// tree.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// This is equivalent to `syn::parse2::&lt;T&gt;(mac.tokens)` except that it</span>
    <span class="doccomment">/// produces a more useful span when `tokens` is empty.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// # Example</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// ```</span>
    <span class="doccomment">/// use syn::{parse_quote, Expr, ExprLit, Ident, Lit, LitStr, Macro, Token};</span>
    <span class="doccomment">/// use syn::ext::IdentExt;</span>
    <span class="doccomment">/// use syn::parse::{Error, Parse, ParseStream, Result};</span>
    <span class="doccomment">/// use syn::punctuated::Punctuated;</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// // The arguments expected by libcore&#39;s format_args macro, and as a</span>
    <span class="doccomment">/// // result most other formatting and printing macros like println.</span>
    <span class="doccomment">/// //</span>
    <span class="doccomment">/// //     println!(&quot;{} is {number:.prec$}&quot;, &quot;x&quot;, prec=5, number=0.01)</span>
    <span class="doccomment">/// struct FormatArgs {</span>
    <span class="doccomment">///     format_string: Expr,</span>
    <span class="doccomment">///     positional_args: Vec&lt;Expr&gt;,</span>
    <span class="doccomment">///     named_args: Vec&lt;(Ident, Expr)&gt;,</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// impl Parse for FormatArgs {</span>
    <span class="doccomment">///     fn parse(input: ParseStream) -&gt; Result&lt;Self&gt; {</span>
    <span class="doccomment">///         let format_string: Expr;</span>
    <span class="doccomment">///         let mut positional_args = Vec::new();</span>
    <span class="doccomment">///         let mut named_args = Vec::new();</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///         format_string = input.parse()?;</span>
    <span class="doccomment">///         while !input.is_empty() {</span>
    <span class="doccomment">///             input.parse::&lt;Token![,]&gt;()?;</span>
    <span class="doccomment">///             if input.is_empty() {</span>
    <span class="doccomment">///                 break;</span>
    <span class="doccomment">///             }</span>
    <span class="doccomment">///             if input.peek(Ident::peek_any) &amp;&amp; input.peek2(Token![=]) {</span>
    <span class="doccomment">///                 while !input.is_empty() {</span>
    <span class="doccomment">///                     let name: Ident = input.call(Ident::parse_any)?;</span>
    <span class="doccomment">///                     input.parse::&lt;Token![=]&gt;()?;</span>
    <span class="doccomment">///                     let value: Expr = input.parse()?;</span>
    <span class="doccomment">///                     named_args.push((name, value));</span>
    <span class="doccomment">///                     if input.is_empty() {</span>
    <span class="doccomment">///                         break;</span>
    <span class="doccomment">///                     }</span>
    <span class="doccomment">///                     input.parse::&lt;Token![,]&gt;()?;</span>
    <span class="doccomment">///                 }</span>
    <span class="doccomment">///                 break;</span>
    <span class="doccomment">///             }</span>
    <span class="doccomment">///             positional_args.push(input.parse()?);</span>
    <span class="doccomment">///         }</span>
    <span class="doccomment">///</span>
    <span class="doccomment">///         Ok(FormatArgs {</span>
    <span class="doccomment">///             format_string,</span>
    <span class="doccomment">///             positional_args,</span>
    <span class="doccomment">///             named_args,</span>
    <span class="doccomment">///         })</span>
    <span class="doccomment">///     }</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// // Extract the first argument, the format string literal, from an</span>
    <span class="doccomment">/// // invocation of a formatting or printing macro.</span>
    <span class="doccomment">/// fn get_format_string(m: &amp;Macro) -&gt; Result&lt;LitStr&gt; {</span>
    <span class="doccomment">///     let args: FormatArgs = m.parse_body()?;</span>
    <span class="doccomment">///     match args.format_string {</span>
    <span class="doccomment">///         Expr::Lit(ExprLit { lit: Lit::Str(lit), .. }) =&gt; Ok(lit),</span>
    <span class="doccomment">///         other =&gt; {</span>
    <span class="doccomment">///             // First argument was not a string literal expression.</span>
    <span class="doccomment">///             // Maybe something like: println!(concat!(...), ...)</span>
    <span class="doccomment">///             Err(Error::new_spanned(other, &quot;format string must be a string literal&quot;))</span>
    <span class="doccomment">///         }</span>
    <span class="doccomment">///     }</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// fn main() {</span>
    <span class="doccomment">///     let invocation = parse_quote! {</span>
    <span class="doccomment">///         println!(&quot;{:?}&quot;, Instant::now())</span>
    <span class="doccomment">///     };</span>
    <span class="doccomment">///     let lit = get_format_string(&amp;invocation).unwrap();</span>
    <span class="doccomment">///     assert_eq!(lit.value(), &quot;{:?}&quot;);</span>
    <span class="doccomment">/// }</span>
    <span class="doccomment">/// ```</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;parsing&quot;</span>)]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">doc_cfg</span>, <span class="ident">doc</span>(<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;parsing&quot;</span>)))]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">parse_body</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">Parse</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
        <span class="self">self</span>.<span class="ident">parse_body_with</span>(<span class="ident">T::parse</span>)
    }

    <span class="doccomment">/// Parse the tokens within the macro invocation&#39;s delimiters using the</span>
    <span class="doccomment">/// given parser.</span>
    <span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;parsing&quot;</span>)]</span>
    <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">doc_cfg</span>, <span class="ident">doc</span>(<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;parsing&quot;</span>)))]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">parse_body_with</span><span class="op">&lt;</span><span class="ident">F</span>: <span class="ident">Parser</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">parser</span>: <span class="ident">F</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">F::Output</span><span class="op">&gt;</span> {
        <span class="kw">let</span> <span class="ident">scope</span> <span class="op">=</span> <span class="ident">delimiter_span_close</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">delimiter</span>);
        <span class="ident"><span class="kw">crate</span>::parse::parse_scoped</span>(<span class="ident">parser</span>, <span class="ident">scope</span>, <span class="self">self</span>.<span class="ident">tokens</span>.<span class="ident">clone</span>())
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;parsing&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">parse_delimiter</span>(<span class="ident">input</span>: <span class="ident">ParseStream</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span>(<span class="ident">MacroDelimiter</span>, <span class="ident">TokenStream</span>)<span class="op">&gt;</span> {
    <span class="ident">input</span>.<span class="ident">step</span>(<span class="op">|</span><span class="ident">cursor</span><span class="op">|</span> {
        <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>((<span class="ident">TokenTree::Group</span>(<span class="ident">g</span>), <span class="ident">rest</span>)) <span class="op">=</span> <span class="ident">cursor</span>.<span class="ident">token_tree</span>() {
            <span class="kw">let</span> <span class="ident">span</span> <span class="op">=</span> <span class="ident">g</span>.<span class="ident">span</span>();
            <span class="kw">let</span> <span class="ident">delimiter</span> <span class="op">=</span> <span class="kw">match</span> <span class="ident">g</span>.<span class="ident">delimiter</span>() {
                <span class="ident">Delimiter::Parenthesis</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">MacroDelimiter::Paren</span>(<span class="ident">Paren</span>(<span class="ident">span</span>)),
                <span class="ident">Delimiter::Brace</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">MacroDelimiter::Brace</span>(<span class="ident">Brace</span>(<span class="ident">span</span>)),
                <span class="ident">Delimiter::Bracket</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">MacroDelimiter::Bracket</span>(<span class="ident">Bracket</span>(<span class="ident">span</span>)),
                <span class="ident">Delimiter::None</span> <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="kw">return</span> <span class="prelude-val">Err</span>(<span class="ident">cursor</span>.<span class="ident">error</span>(<span class="string">&quot;expected delimiter&quot;</span>));
                }
            };
            <span class="prelude-val">Ok</span>(((<span class="ident">delimiter</span>, <span class="ident">g</span>.<span class="ident">stream</span>()), <span class="ident">rest</span>))
        } <span class="kw">else</span> {
            <span class="prelude-val">Err</span>(<span class="ident">cursor</span>.<span class="ident">error</span>(<span class="string">&quot;expected delimiter&quot;</span>))
        }
    })
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;parsing&quot;</span>)]</span>
<span class="kw">pub</span> <span class="kw">mod</span> <span class="ident">parsing</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;
    <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::parse</span>::{<span class="ident">Parse</span>, <span class="ident">ParseStream</span>, <span class="prelude-ty">Result</span>};

    <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">doc_cfg</span>, <span class="ident">doc</span>(<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;parsing&quot;</span>)))]</span>
    <span class="kw">impl</span> <span class="ident">Parse</span> <span class="kw">for</span> <span class="ident">Macro</span> {
        <span class="kw">fn</span> <span class="ident">parse</span>(<span class="ident">input</span>: <span class="ident">ParseStream</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span><span class="op">&gt;</span> {
            <span class="kw">let</span> <span class="ident">tokens</span>;
            <span class="prelude-val">Ok</span>(<span class="ident">Macro</span> {
                <span class="ident">path</span>: <span class="ident">input</span>.<span class="ident">call</span>(<span class="ident">Path::parse_mod_style</span>)<span class="question-mark">?</span>,
                <span class="ident">bang_token</span>: <span class="ident">input</span>.<span class="ident">parse</span>()<span class="question-mark">?</span>,
                <span class="ident">delimiter</span>: {
                    <span class="kw">let</span> (<span class="ident">delimiter</span>, <span class="ident">content</span>) <span class="op">=</span> <span class="ident">parse_delimiter</span>(<span class="ident">input</span>)<span class="question-mark">?</span>;
                    <span class="ident">tokens</span> <span class="op">=</span> <span class="ident">content</span>;
                    <span class="ident">delimiter</span>
                },
                <span class="ident">tokens</span>,
            })
        }
    }
}

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;printing&quot;</span>)]</span>
<span class="kw">mod</span> <span class="ident">printing</span> {
    <span class="kw">use</span> <span class="kw">super</span>::<span class="kw-2">*</span>;
    <span class="kw">use</span> <span class="ident">proc_macro2::TokenStream</span>;
    <span class="kw">use</span> <span class="ident">quote::ToTokens</span>;

    <span class="attribute">#[<span class="ident">cfg_attr</span>(<span class="ident">doc_cfg</span>, <span class="ident">doc</span>(<span class="ident">cfg</span>(<span class="ident">feature</span> <span class="op">=</span> <span class="string">&quot;printing&quot;</span>)))]</span>
    <span class="kw">impl</span> <span class="ident">ToTokens</span> <span class="kw">for</span> <span class="ident">Macro</span> {
        <span class="kw">fn</span> <span class="ident">to_tokens</span>(<span class="kw-2">&amp;</span><span class="self">self</span>, <span class="ident">tokens</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident">TokenStream</span>) {
            <span class="self">self</span>.<span class="ident">path</span>.<span class="ident">to_tokens</span>(<span class="ident">tokens</span>);
            <span class="self">self</span>.<span class="ident">bang_token</span>.<span class="ident">to_tokens</span>(<span class="ident">tokens</span>);
            <span class="kw">match</span> <span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">delimiter</span> {
                <span class="ident">MacroDelimiter::Paren</span>(<span class="ident">paren</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="ident">paren</span>.<span class="ident">surround</span>(<span class="ident">tokens</span>, <span class="op">|</span><span class="ident">tokens</span><span class="op">|</span> <span class="self">self</span>.<span class="ident">tokens</span>.<span class="ident">to_tokens</span>(<span class="ident">tokens</span>));
                }
                <span class="ident">MacroDelimiter::Brace</span>(<span class="ident">brace</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="ident">brace</span>.<span class="ident">surround</span>(<span class="ident">tokens</span>, <span class="op">|</span><span class="ident">tokens</span><span class="op">|</span> <span class="self">self</span>.<span class="ident">tokens</span>.<span class="ident">to_tokens</span>(<span class="ident">tokens</span>));
                }
                <span class="ident">MacroDelimiter::Bracket</span>(<span class="ident">bracket</span>) <span class="op">=</span><span class="op">&gt;</span> {
                    <span class="ident">bracket</span>.<span class="ident">surround</span>(<span class="ident">tokens</span>, <span class="op">|</span><span class="ident">tokens</span><span class="op">|</span> <span class="self">self</span>.<span class="ident">tokens</span>.<span class="ident">to_tokens</span>(<span class="ident">tokens</span>));
                }
            }
        }
    }
}
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="syn" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>